class Hash
  module DynamicMatcher
    private

    def method_missing(name, *args, &block)
      t_key = match(name)

      return send(finder, t_key) if t_key
      super
    end

    def match(name)
      return name.to_s if send(matcher, name.to_s)
      return name.to_sym if send(matcher, name.to_sym)
      nil
    end

    def matcher
      'has_key?'
    end

    def finder
      'fetch'
    end
  end
end
